//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(SpeedSPDBcleDts)
{
	baseShape  = "./SpeedBicycle.dts";
	sequence0  = "./SpedBik_root.dsq root";

	sequence1  = "./SpedBik_run.dsq run";
	sequence2  = "./SpedBik_run.dsq walk";
	sequence3  = "./SpedBik_root.dsq back";
	sequence4  = "./SpedBik_root.dsq side";

	sequence5  = "./SpedBik_run.dsq crouch";
	sequence6  = "./SpedBik_run.dsq crouchRun";
	sequence7  = "./SpedBik_root.dsq crouchBack";
	sequence8  = "./SpedBik_root.dsq crouchSide";

	sequence9  = "./SpedBik_root.dsq look";
	sequence10 = "./SpedBik_root.dsq headside";
	sequence11 = "./SpedBik_root.dsq headUp";

	sequence12 = "./SpedBik_jump.dsq jump";
	sequence13 = "./SpedBik_jump.dsq standjump";
	sequence14 = "./SpedBik_fall.dsq fall";
	sequence15 = "./SpedBik_land.dsq land";

	sequence16 = "./SpedBik_root.dsq armAttack";
	sequence17 = "./SpedBik_root.dsq armReadyLeft";
	sequence18 = "./SpedBik_root.dsq armReadyRight";
	sequence19 = "./SpedBik_root.dsq armReadyBoth";
	sequence20 = "./SpedBik_root.dsq spearready";  
	sequence21 = "./SpedBik_root.dsq spearThrow";

	sequence22 = "./SpedBik_root.dsq talk";  

	sequence23 = "./SpedBik_death.dsq death1"; 
	
	sequence24 = "./SpedBik_root.dsq shiftUp";
	sequence25 = "./SpedBik_root.dsq shiftDown";
	sequence26 = "./SpedBik_root.dsq shiftAway";
	sequence27 = "./SpedBik_root.dsq shiftTo";
	sequence28 = "./SpedBik_root.dsq shiftLeft";
	sequence29 = "./SpedBik_root.dsq shiftRight";
	sequence30 = "./SpedBik_root.dsq rotCW";
	sequence31 = "./SpedBik_root.dsq rotCCW";

	sequence32 = "./SpedBik_root.dsq undo";
	sequence33 = "./SpedBik_root.dsq plant";

	sequence34 = "./SpedBik_root.dsq sit";

	sequence35 = "./SpedBik_root.dsq wrench";

   sequence36 = "./SpedBik_root.dsq activate";
   sequence37 = "./SpedBik_root.dsq activate2";

   sequence38 = "./SpedBik_root.dsq leftrecoil";
};    


//datablock AudioProfile(BicyleJumpSound)
//{
//   fileName = "./bicycle.wav";
//   description = AudioClose3d;
//   preload = true;
//};


datablock DebrisData( SpeedSPDBcleDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(SpeedSPDBcleArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./SpeedBicycle.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = SpeedSPDBcleDebris;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 80;
   drag = 0;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 16 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 14;
   maxBackwardSpeed = 4;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 14;
   maxBackwardCrouchSpeed = 1;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 20;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 7 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2 2 2.25", 2.25);
   crouchBoundingBox	= vectorScale("2 2 2.25", 2.25);
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = SpeedSPDBcleFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

//   JumpSound			= SpeedSPDBcleJumpSound;

   // Footstep Sounds
//   FootSoftSound        = SpeedSPDBcleFootFallSound;
//   FootHardSound        = SpeedSPDBcleFootFallSound;
//   FootMetalSound       = SpeedSPDBcleFootFallSound;
//   FootSnowSound        = SpeedSPDBcleFootFallSound;
//   FootShallowSound     = SpeedSPDBcleFootFallSound;
//   FootWadingSound      = SpeedSPDBcleFootFallSound;
//   FootUnderwaterSound  = SpeedSPDBcleFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Bicycle Speed";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.64;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = SpeedSPDBcleBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[5] = "armreadyboth";
   mountNode[0] = 5;
};



function SpeedSPDBcleArmor::onAdd(%this,%obj)
{
   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRepairRate(0);

}



//called when the driver of a player-vehicle is unmounted
function SpeedSPDBcleArmor::onDriverLeave(%obj, %player)
{
	//do nothing
}